--------------------------------------------------------------------------------
-- Test balancing conversions
--------------------------------------------------------------------------------

{-# LANGUAGE DataKinds              #-}
{-# LANGUAGE PolyKinds              #-}
{-# LANGUAGE TypeFamilies           #-}
{-# LANGUAGE GADTs                  #-}
{-# LANGUAGE FlexibleContexts       #-}
{-# LANGUAGE FlexibleInstances      #-}
{-# LANGUAGE ScopedTypeVariables    #-}
{-# LANGUAGE TypeOperators          #-}
{-# LANGUAGE DefaultSignatures      #-}

module Test.Balancing where


import Test.Structured
import Library.Structured
import Conversion.S2RS

--------------------------------------------------------------------------------
-- Testing balancing
--------------------------------------------------------------------------------

class CountSums (a :: *) where
  countSums :: a -> Int

class CountSumsG u where
  countSumsG :: In u x -> Int

instance (CountSumsG a) => CountSumsG ('UData md a) where
  countSumsG (D1 x) = countSumsG x

instance CountSumsG ('Empty)  where countSumsG _ = 0
instance CountSumsG ('Leaf a) where countSumsG _ = 0

instance (CountSumsG x, CountSumsG y) => CountSumsG ('Bin x y :: Tree (UCon k)) where
  countSumsG (L1 x) = 1 + countSumsG x
  countSumsG (R1 x) = 1 + countSumsG x


countSumsBal :: (Generic a, CountSumsG (Rep a)) => a -> Int
countSumsBal = countSumsG . from

countSumsR :: (Generic a, Convert (Rep a), CountSumsG (S2RS (Rep a))) => a -> Int
countSumsR = countSumsG . s2rs . from

testCountSums :: ([Int],[Int])
testCountSums = (map countSumsBal [A,B,C,D], map countSumsR [A,B,C,D])
